<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>

    <script src="../lib/ResizeDecoratorsCollection.js"></script>

  </head>
  <body>

    <script>

    setup (() => {
        this.EXPECTED_WIDTH = 10;
        this.resizers = new ResizeDecoratorsCollection({
            createResizeDecorator: (d, m) => {
                return {width: this.EXPECTED_WIDTH, remove: () => {}}
            }
        });
        this.rect = {middle: (d) => {return {}}}
    })

    test('should have a margin of 0', () => {
        assert.equal(0, this.resizers.margin())
    })

    test('should have a margin equal to the left decorator width', () => {
        this.resizers.decorate(this.rect);
        assert.equal(this.EXPECTED_WIDTH, this.resizers.margin("LEFT"))
    })

    test('should have a margin equal to the right decorator width', () => {
        this.resizers.decorate(this.rect);
        assert.equal(this.EXPECTED_WIDTH, this.resizers.margin("RIGHT"))
    })

    test('should have a margin of 0 after delete all decorators', () => {
        this.resizers.decorate(this.rect);
        this.resizers.deleteAll();
        assert.equal(0, this.resizers.margin("RIGHT"))
        assert.equal(0, this.resizers.margin("LEFT"))
    })

    </script>

  </body>
</html>
